%ifnarch %{ocaml_native_compiler}
%global debug_package %{nil}
%endif

%global srcname ppx-base
%global upname  ppx_base

Name:           ocaml-%{srcname}
Version:        0.14.0
Release:        1%{?dist}
Summary:        Base set of OCaml ppx rewriters

License:        MIT
URL:            https://github.com/janestreet/%{upname}
Source0:        %{url}/archive/v%{version}/%{upname}-%{version}.tar.gz

BuildRequires:  ocaml >= 4.04.2
BuildRequires:  ocaml-dune >= 2.0.0
BuildRequires:  (ocaml-ppx-cold-devel >= 0.14 with ocaml-ppx-cold-devel < 0.15)
BuildRequires:  (ocaml-ppx-compare-devel >= 0.14 with ocaml-ppx-compare-devel < 0.15)
BuildRequires:  (ocaml-ppx-enumerate-devel >= 0.14 with ocaml-ppx-enumerate-devel < 0.15)
BuildRequires:  (ocaml-ppx-hash-devel >= 0.14 with ocaml-ppx-hash-devel < 0.15)
BuildRequires:  (ocaml-ppx-js-style-devel >= 0.14 with ocaml-ppx-js-style-devel < 0.15)
BuildRequires:  (ocaml-ppx-sexp-conv-devel >= 0.14 with ocaml-ppx-sexp-conv-devel < 0.15)
BuildRequires:  ocaml-ppxlib-devel >= 0.11.0
BuildRequires:  ocaml-odoc

%description
Ppx_base is the set of ppx rewriters used for Base.  Note that Base
doesn't need ppx to build; it is only used as a verification tool.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:       ocaml-ppx-cold-devel%{?_isa}
Requires:       ocaml-ppx-compare-devel%{?_isa}
Requires:       ocaml-ppx-enumerate-devel%{?_isa}
Requires:       ocaml-ppx-hash-devel%{?_isa}
Requires:       ocaml-ppx-js-style-devel%{?_isa}
Requires:       ocaml-ppx-sexp-conv-devel%{?_isa}

%description    devel
The %{name}-devel package contains libraries and signature
files for developing applications that use %{name}.

%prep
%autosetup -n %{upname}-%{version}

%build
dune build %{?_smp_mflags} --display=verbose
dune build %{?_smp_mflags} @doc

%install
dune install --destdir=%{buildroot}

# We do not want the dune markers
find _build/default/_doc/_html -name .dune-keep -delete

# We do not want the ml files
find %{buildroot}%{_libdir}/ocaml -name \*.ml -delete

# We install the documentation with the doc macro
rm -fr %{buildroot}%{_prefix}/doc

%ifarch %{ocaml_native_compiler}
# Add missing executable bits
find %{buildroot}%{_libdir}/ocaml -name \*.cmxs -exec chmod a+x {} \+
%endif

%check
dune runtest

%files
%license LICENSE.md
%dir %{_libdir}/ocaml/%{upname}/
%{_bindir}/ppx-base
%{_libdir}/ocaml/%{upname}/META
%{_libdir}/ocaml/%{upname}/ppx.exe
%{_libdir}/ocaml/%{upname}/*.cma
%{_libdir}/ocaml/%{upname}/*.cmi
%ifarch %{ocaml_native_compiler}
%{_libdir}/ocaml/%{upname}/*.cmxs
%endif

%files devel
%doc _build/default/_doc/_html/*
%{_libdir}/ocaml/%{upname}/dune-package
%{_libdir}/ocaml/%{upname}/opam
%ifarch %{ocaml_native_compiler}
%{_libdir}/ocaml/%{upname}/*.a
%{_libdir}/ocaml/%{upname}/*.cmx
%{_libdir}/ocaml/%{upname}/*.cmxa
%endif
%{_libdir}/ocaml/%{upname}/*.cmt

%changelog
* Sat Jun 20 2020 Jerry James <loganjerry@gmail.com> - 0.14.0-1
- Initial RPM
